/*******************************************************************************

        @file Iso8859_1.d
        
        Copyright (C) 2004 Kris Bell
        
        This software is provided 'as-is', without any express or implied
        warranty. In no event will the authors be held liable for damages
        of any kind arising from the use of this software.
        
        Permission is hereby granted to anyone to use this software for any 
        purpose, including commercial applications, and to alter it and/or 
        redistribute it freely, subject to the following restrictions:
        
        1. The origin of this software must not be misrepresented; you must 
           not claim that you wrote the original software. If you use this 
           software in a product, an acknowledgment within documentation of 
           said product would be appreciated but is not required.

        2. Altered source versions must be plainly marked as such, and must 
           not be misrepresented as being the original software.

        3. This notice may not be removed or altered from any distribution
           of the source.


                        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


        @version        Initial version, August 2004      
        @author         Kris


*******************************************************************************/

module mango.xcode.Iso8859_1;

private import mango.xcode.Transcoder;

/*******************************************************************************

*******************************************************************************/

class TranscoderIso8859_1 : Transcoder
{
        /***********************************************************************

        ***********************************************************************/

        char[] toString ()
        {
                return "iso-8859-1";
        }

        /***********************************************************************

        ***********************************************************************/

        char[] encode (dchar[] input, char[] output, out uint consumed)
        {
                dchar*  pIn = input;
                dchar*  limit = pIn + input.length;

                foreach (inout char d; output)
                        {
                        if (pIn < limit)
                           {
                           dchar b = *pIn++;
                         
                           if (b > 0xff)
                               fault ("invalid input while encoding");

                           d = cast(char) b;
                           }
                        else
                           break;
                        } 
        
                return output [0..(consumed = pIn - &input[0])];
        }


        /***********************************************************************

        ***********************************************************************/

        dchar[] decode (char[] input, dchar[] output, out uint consumed)
        {
                char*   pIn = input;
                char*   limit = pIn + input.length;

                foreach (inout dchar d; output)
                        {
                        if (pIn < limit)
                            d = cast(dchar) *pIn++;
                        else
                           break;
                        } 
                
                return output [0..(consumed = pIn - &input[0])];
        }
}
