/*******************************************************************************

        @file Transcoder.d
        
        Copyright (C) 2004 Kris Bell
        
        This software is provided 'as-is', without any express or implied
        warranty. In no event will the authors be held liable for damages
        of any kind arising from the use of this software.
        
        Permission is hereby granted to anyone to use this software for any 
        purpose, including commercial applications, and to alter it and/or 
        redistribute it freely, subject to the following restrictions:
        
        1. The origin of this software must not be misrepresented; you must 
           not claim that you wrote the original software. If you use this 
           software in a product, an acknowledgment within documentation of 
           said product would be appreciated but is not required.

        2. Altered source versions must be plainly marked as such, and must 
           not be misrepresented as being the original software.

        3. This notice may not be removed or altered from any distribution
           of the source.


                        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


        @version        Initial version, August 2004      
        @author         Kris


*******************************************************************************/

module mango.xcode.Transcoder;

/*******************************************************************************
      
*******************************************************************************/

class Transcoder
{
        /***********************************************************************

                Convert the input into the output, respecting the boundaries
                of the provided arrays. Returns a valid slice of the output,
                along with the number of items consumed from the input.

        ***********************************************************************/

        abstract char[] encode (dchar[] input, char[] output, out uint consumed);

        /***********************************************************************
      
                Convert the input into the output, respecting the boundaries
                of the provided arrays. Returns a valid slice of the output,
                along with the number of items consumed from the input.

        ***********************************************************************/

        abstract dchar[] decode (char[] input, dchar[] output, out uint consumed);

        /***********************************************************************
      
                Return the encoding name of this transcoder 

        ***********************************************************************/

        abstract char[] toString ();

        /***********************************************************************

                overridable exception thrower

        ***********************************************************************/

        protected void fault (char[] msg)
        {
                throw new Exception (msg);
        } 
}

