# Designed to work with \dm\bin\make.exe
# Targets:
#
#	make unittest
#		Build mango.io package, and create mango/obj/mango.exe
# Notes:
#	This relies on LIB.EXE 8.00 or later, and MAKE.EXE 5.01 or later.


#DFLAGS	=	-O -g -release -version=UseShiftOperators
DFLAGS =	-g -version=UseShiftOperators 



DMD =		dmd
LIB = 		/dm/bin/lib
OBJ =		obj/

EXAMPLE = 	example/
MANGO =		mango
BASE =   	$(MANGO)/base/
TEST =   	$(MANGO)/test/
UTILS =   	$(MANGO)/utils/
UTILSMODEL =	$(MANGO)/utils/model/
IO =		$(MANGO)/io/
IOMODEL =	$(MANGO)/io/model/
CACHE =		$(MANGO)/cache/
CACHEMODEL =	$(MANGO)/cache/model/
SERVERMODEL =	$(MANGO)/http/server/model/
HTTPCLIENT =	$(MANGO)/http/client/
HTTP =		$(MANGO)/http/
HTTPUTILS =	$(MANGO)/http/utils/
HTTPSERVER =	$(MANGO)/http/server/
SERVLET =	$(MANGO)/servlet/
SERVLETMODEL =	$(MANGO)/servlet/model/
LOG =		$(MANGO)/log/
LOGMODEL =	$(MANGO)/log/model/
CLUSTER =	$(MANGO)/cluster/
CLUSTERMODEL =	$(MANGO)/cluster/model/
CLUSTERSOCKET =	$(MANGO)/cluster/qos/socket/
XML =           $(MANGO)/xml/
SAX =           $(MANGO)/xml/sax/
SAXMODEL =      $(MANGO)/xml/sax/model/

COMPILE = 	$(DMD) -c $(DFLAGS) -od$(OBJ) $**

.obj.d :
	$(COMPILE)


SRC=	$(BASE)System.d \
	$(BASE)ByteSwap.d \
	$(UTILS)Timer.d \
	$(UTILS)Text.d \
	$(UTILS)Random.d \
	$(UTILS)HeapSlice.d \
	$(UTILS)AbstractServer.d \
	$(UTILS)ServerThread.d \
	$(UTILSMODEL)IServer.d \
	$(IOMODEL)IBuffer.d \
	$(IOMODEL)IResource.d \
	$(IOMODEL)IConduit.d \
	$(IOMODEL)IReader.d \
	$(IOMODEL)IWriter.d \
	$(IOMODEL)IPickle.d \
	$(IOMODEL)IBitBucket.d \
	$(IO)ArrayAllocator.d \
	$(IO)TextFormat.d \
	$(IO)TextLayout.d \
	$(IO)Exception.d \
	$(IO)FileStyle.d \
	$(IO)FilePath.d \
	$(IO)ConduitStyle.d \
	$(IO)Conduit.d \
	$(IO)Buffer.d \
	$(IO)Resource.d \
	$(IO)FileSystem.d \
	$(IO)FileConduit.d \
	$(IO)FileProxy.d \
	$(IO)EndianReader.d \
	$(IO)EndianWriter.d \
	$(IO)Token.d \
	$(IO)TokenEx.d \
	$(IO)Tokenizer.d \
	$(IO)TextWriter.d \
	$(IO)TextReader.d \
	$(IO)DisplayWriter.d \
	$(IO)ColumnWriter.d \
	$(IO)Stdio.d \
	$(IO)AbstractReader.d \
	$(IO)AbstractWriter.d \
	$(IO)Reader.d \
	$(IO)Writer.d \
	$(IO)Socket.d \
	$(IO)PickleRegistry.d \
	$(IO)PickleReader.d \
	$(IO)PickleWriter.d \
	$(IO)FileBucket.d \
	$(IO)Uri.d \
	$(IO)SocketConduit.d \
	$(IO)ServerSocket.d \
	$(IO)DatagramSocket.d \
	$(IO)MulticastSocket.d \
	$(IO)SocketListener.d \
	$(IO)Properties.d \
	$(CACHEMODEL)ICache.d \
	$(CACHEMODEL)IPayload.d \
	$(CACHE)HashMap.d \
	$(CACHE)PlainCache.d \
	$(CACHE)Payload.d \
	$(CACHE)QueuedCache.d \
	$(CACHE)VirtualCache.d \
	$(SERVERMODEL)IProvider.d \
	$(SERVERMODEL)IProviderBridge.d \
	$(HTTP)HttpReader.d \
	$(HTTP)HttpWriter.d \
	$(HTTPUTILS)TokenStack.d \
	$(HTTPUTILS)Dictionary.d \
	$(HTTPSERVER)HttpTokens.d \
	$(HTTPSERVER)HttpParams.d \
	$(HTTPSERVER)HttpHeaders.d \
	$(HTTPSERVER)HttpCookies.d \
	$(HTTPSERVER)HttpBridge.d \
	$(HTTPSERVER)HttpMessage.d \
	$(HTTPSERVER)HttpRequest.d \
	$(HTTPSERVER)HttpResponse.d \
	$(HTTPSERVER)HttpProvider.d \
	$(HTTPSERVER)HttpServer.d \
	$(HTTPSERVER)HttpThread.d \
	$(HTTPCLIENT)HttpClient.d \
	$(SERVLETMODEL)IServletRequest.d \
	$(SERVLETMODEL)IServletResponse.d \
	$(SERVLET)ServletConfig.d \
	$(SERVLET)Servlet.d \
	$(SERVLET)ServletRequest.d \
	$(SERVLET)ServletResponse.d \
	$(SERVLET)ServletProvider.d \
	$(SERVLET)ServletContext.d \
	$(LOGMODEL)ILevel.d \
	$(LOGMODEL)ILogger.d \
	$(LOG)Admin.d \
	$(LOG)Hierarchy.d \
	$(LOG)Manager.d \
	$(LOG)Logger.d \
	$(LOG)Event.d \
	$(LOG)Layout.d \
	$(LOG)XmlLayout.d \
	$(LOG)DateLayout.d \
	$(LOG)Appender.d \
	$(LOG)SocketAppender.d \
	$(LOG)Configurator.d \
	$(LOG)FileAppender.d \
	$(LOG)RollingFileAppender.d \
	$(LOG)StdioAppender.d \
	$(LOG)ConsoleAppender.d \
	$(CLUSTERMODEL)ICluster.d \
	$(CLUSTERMODEL)IChannel.d \
	$(CLUSTERMODEL)IEvent.d \
	$(CLUSTERMODEL)IMessage.d \
	$(CLUSTERMODEL)IConsumer.d \
	$(CLUSTER)Client.d \
	$(CLUSTER)CacheInvalidator.d \
	$(CLUSTER)CacheInvalidatee.d \
	$(CLUSTER)NetworkCache.d \
	$(CLUSTER)NetworkQueue.d \
	$(CLUSTER)NetworkAlert.d \
	$(CLUSTER)Message.d \
	$(CLUSTER)TaskServer.d \
	$(CLUSTERSOCKET)ProtocolWriter.d \
	$(CLUSTERSOCKET)ProtocolReader.d \
	$(CLUSTERSOCKET)Cluster.d \
	$(CLUSTERSOCKET)RollCall.d \
	$(CLUSTERSOCKET)ClusterEvent.d \
	$(CLUSTERSOCKET)ClusterThread.d \
	$(CLUSTERSOCKET)ClusterServer.d \
	$(CLUSTERSOCKET)ClusterCache.d \
#	$(XML)java.d \
#	$(XML)SaxDriver.d \
#	$(XML)Stack.d \
#	$(XML)XmlParser.d \
#	$(SAXMODEL)IAttributeList.d \
#	$(SAXMODEL)IAttributes2.d \
#	$(SAXMODEL)IAttributes.d \
#	$(SAXMODEL)IContentHandler.d \
#	$(SAXMODEL)IDeclHandler.d \
#	$(SAXMODEL)IDocumentHandler.d \
#	$(SAXMODEL)IDTDHandler.d \
#	$(SAXMODEL)IEntityResolver2.d \
#	$(SAXMODEL)IEntityResolver.d \
#	$(SAXMODEL)IErrorHandler.d \
#	$(SAXMODEL)ILexicalHandler.d \
#	$(SAXMODEL)ILocator2.d \
#	$(SAXMODEL)ILocator.d \
#	$(SAXMODEL)IParser.d \
#	$(SAXMODEL)IXMLFilter.d \
#	$(SAXMODEL)IXMLReader.d \
#	$(SAX)AttributeListImpl.d \
#	$(SAX)Attributes2Impl.d \
#	$(SAX)AttributesImpl.d \
#	$(SAX)DefaultHandler2.d \
#	$(SAX)DefaultHandler.d \
#	$(SAX)HandlerBase.d \
#	$(SAX)InputSource.d \
#	$(SAX)Locator2Impl.d \
#	$(SAX)LocatorImpl.d \
#	$(SAX)NamespaceSupport.d \
#	$(SAX)ParserAdapter.d \
#	$(SAX)ParserFactory.d \
#	$(SAX)SaxException.d \
#	$(SAX)XMLFilterImpl.d \
#	$(SAX)XMLReaderAdapter.d \
#	$(SAX)XMLReaderFactory.d \


unittest : $(SRC) $(TEST)unittest.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\mango $(OBJ)*.obj wsock32.lib 
#	 $(DMD) -g -of.\obj\mango $(OBJ)unittest.obj $(OBJ)mango.lib wsock32.lib 
	 del *.map

lib 	: $(SRC)
         cd $(OBJ)
	 dir *.obj /b > mango.rsp
	 $(LIB) -c -n -p256 mango.lib @mango.rsp
         cd ..

servlets : $(SRC) $(EXAMPLE)servlets.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\servlets $(OBJ)*.obj wsock32.lib

pickle : $(SRC) $(EXAMPLE)pickle.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\pickle $(OBJ)*.obj wsock32.lib

cclient : $(SRC) $(EXAMPLE)cclient.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\cclient $(OBJ)*.obj wsock32.lib

cserver : $(SRC) $(EXAMPLE)cserver.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -L/PACKF -g -of.\obj\cserver $(OBJ)*.obj wsock32.lib

tserver : $(SRC) $(EXAMPLE)tserver.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -L/PACKF -g -of.\obj\tserver $(OBJ)*.obj wsock32.lib

multicast : $(SRC) $(EXAMPLE)multicast.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\multicast $(OBJ)*.obj wsock32.lib

alert : $(SRC) $(EXAMPLE)alert.d
	 del obj\*.obj
	 $(COMPILE)
	 $(DMD) -g -of.\obj\alert $(OBJ)*.obj wsock32.lib
